plugins['queuereadycounter'] = (function() {

    clearInterval(window.queuereadycounterinterval);
    window.queuereadycounterinterval=setInterval(function(){plugins['queuereadycounter'].updategraph();},500);

    if(typeof window.dataqueuereadycounter == 'undefined') {
        window.dataqueuereadycounter = new Array();
    }

    var currenttotal     = 0;
    var currentavailable = 0;
    var plot;
    var maxy = 5;
    var lastsecond = -1;

    return { 

        loadLang: function(values) {
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~queuereadycounter" + "|" + hash + "\" />";
            sendcommand();
        },
        setLang: function() {
            if($('#queuereadycountTitle').length>0) {
                debug('set lang queuereadycounter');
                $('#queuereadycountTitle').html(lang.queuereadycounter);
                $('#box_queuereadycounterbox .langcollapse').attr('data-original-title',lang.collapse);
                $('#box_queuereadycounterbox .langlockunlock').attr('data-original-title',lang.toggle_lock);
            }
        },
        init: function() {
            // initialization function
        },
        updategraph: function() {

            if ($('#box_asternicTagbox').length > 0) {
                return;
            }

            if(typeof plot != 'undefined') {
                if ($('#queuereadycountergraph').length > 0) {

                    var d = new Date();
                    var n = d.getSeconds();
                    if(n==lastsecond) {
                        lastsecond=n;
                        return;
                    }
                    lastsecond=n;

                    window.dataqueuereadycounter.shift();
                    window.dataqueuereadycounter.push(currentavailable);
                    var res = [];
                    max=0;
                    for (var i = 0; i < window.dataqueuereadycounter.length; ++i) {
                        res.push([i, window.dataqueuereadycounter[i]]);
                        if(window.dataqueuereadycounter[i]>max) { max = window.dataqueuereadycounter[i]; }
                    }
                    if(max > maxy) {
                        maxy+=10;
                        plot = $.plot("#queuereadycountergraph", [ res ], {
                            series: { shadowSize:0, lines: { show: true, fill: true, fillColor: { colors:[{ opacity: 0.9},{opacity: 0.1}]}} },
                            colors: ['#57889c'],
                            yaxis: { 'min': 0, 'max': maxy },
                            xaxis: { ticks: [[0,'5 min'],[60,'4 min'],[120,'3 min'],[180,'2 min'],[240,'1 min']], show: true }
                        });
                    } else if(max < (maxy - 10)) {
                        maxy-=10;
                        plot = $.plot("#queuereadycountergraph", [ res ], {
                            series: { shadowSize:0, lines: { show: true, fill: true, fillColor: { colors:[{ opacity: 0.9},{opacity: 0.1}]}} },
                            colors: ['#57889c'],
                            yaxis: { 'min': 0, 'max': maxy },
                            xaxis: { ticks: [[0,'5 min'],[60,'4 min'],[120,'3 min'],[180,'2 min'],[240,'1 min']], show: true }
                        });
                    } else {
                        plot.setData([res]);
                        plot.draw();
                    }
                }
            } else {

                if(window.dataqueuereadycounter.length == 0) {
                    for(a=0;a<300;a++) {
                       window.dataqueuereadycounter[a]=0;
                    }
                }
                var res = [];
                for (var i = 0; i < window.dataqueuereadycounter.length; ++i) {
                  res.push([i, window.dataqueuereadycounter[i]])
                }

                if ($('#queuereadycountergraph').length > 0) {
                    plot = $.plot("#queuereadycountergraph", [ res ], {
                        series: { shadowSize:0, lines: { show: true, fill: true, fillColor: { colors:[{ opacity: 0.9},{opacity: 0.1}]}} },
                        colors: ['#57889c'],
                        yaxis: { 'min': 0, 'max': maxy },
                        xaxis: { ticks: [[0,'5 min'],[60,'4 min'],[120,'3 min'],[180,'2 min'],[240,'1 min']], show: true }
                    });

                    $("#queuereadycountergraph").resizable({});
                }
            }
        },
        callback_zbuttons: function() {

            var oldclient=0;
            if ($('#box_asternicTagbox').length > 0) {
                oldclient=1;
            }

            if($('#box_queuereadycounterbox').length<=0) {
               if (oldclient==1) {
                    var klon = $( '#box_asternicTagbox' );
                    var newklon = klon.clone().attr( { id: 'box_queuereadycounterbox' }).css({display: 'block'}).insertBefore( klon );
                    newklon.find('*').each(function() {
                       if(typeof $(this).attr('id') == 'undefined') {
                       } else {
                           if($(this).attr('id')=='tagcall') { $(this).attr('id','queuereadycountTitle').html(lang.queuereadycounter); }
                           if($(this).attr('id')=='toggle-asternicTag') { $(this).attr('id','toggle-queuereadycounter'); }
                           if($(this).attr('id')=='asternicTag') { $(this).attr('id','queuereadycounter').css('text-align','center'); }
                       }
                    });
                } else {
                   // New bootstrap client
                   var newklon = $('<div class="grid-stack-item" id="box_queuereadycounterbox" ><div class="grid-stack-item-content boxstyle boxstylebg"><div id="queuereadycountercontent" class="widgetcontent widget widget-color"><header role="heading"><div class="widget-ctrls" role="menu"><a class="myclick button-icon widget-toggle-btn langcollapse" data-toggle="tooltip" rel="tooltip" title="" data-placement="bottom" data-original-title="Collapse"><i class="fa fa-caret-square-o-up"></i></a><a class="myclick button-icon widget-lock-btn langlockunlock" data-toggle="tooltip" rel="tooltip" title="" data-placement="bottom" data-original-title="Lock/Unlock"><i class="fa fa-unlock-alt"></i></a></div><span class="handle widget-icon"><i class="fa fa-bars"></i></span><h3><span id="queuereadycountTitle">Agents Paused</span></h3></header><div class="widgetscroll" id="queuereadycounterlist"><div id="queuereadycounter" class="text-center" style="padding-top:5px;"><h1>0</h1></div><div id="queuereadycountergraph" style="width:100%; height:150px;"></div></div></div></div>');
                   grid = $('.grid-stack').data('gridstack');

                   window.resizinggrid=1;
                   if(parseInt(currentrelease.replace(/\./g,''))>23101) {
                       grid.addWidget(newklon,0,0,3,6,true);
                   } else {
                       grid.add_widget(newklon,0,0,3,6,true);
                   }
                   window.resizinggrid=0;
           
                   $('#box_queuereadycounterbox [data-toggle="tooltip"]').tooltip({container:'body'});
               }
            }

            if (oldclient==1) {
                makeSortable('right');

                if(typeof(mypreferences.rightColumnOrder)=='string') {
                    ordenarDiv('right_column',mypreferences.rightColumnOrder);
                }
            } else {
               window.resizinggrid=1;
               var jsongrid = Base64.decode(mypreferences.grid);
               if(jsongrid.length>0) {
                   try {
                       var dita = JSON.parse(jsongrid);
                       for (var item in dita) {
                           if(dita[item].id=='box_queuereadycounterbox') {
                               grid.update($('#'+dita[item].id),dita[item].x,dita[item].y,dita[item].width,dita[item].height);
                           }
                       }
                   } catch(e) {
                       debug('Invalid JSON in grid pref');
                   }
               }
               window.resizinggrid=0;
            }

        },
        calculate_ready:  function() {
            agents_notready = {};
            agents_total    = {};
            $('.memberpaused').each(function() {
               chan   = $(this).data('channel').split('~')[2];
               agents_notready[chan]=1;
            });
            $('.memberbusypaused').each(function() {
               chan   = $(this).data('channel').split('~')[2];
               agents_notready[chan]=1;
            });
            $('.memberinvalid').each(function() {
               chan   = $(this).data('channel').split('~')[2];
               agents_notready[chan]=1;
            });
             $('.memberbusy').each(function() {
               chan   = $(this).data('channel').split('~')[2];
               agents_notready[chan]=1;
            });
 
            $('.ctxmenuqueue').each(function() { agents_total[$(this).data('channel').split('~')[2]]=1;});

            currentnotready = Object.keys(agents_notready).length;
            currenttotal  = Object.keys(agents_total).length;
            currentavailable = currenttotal - currentnotready;
            if(currentavailable <= 0 ){ currentavailable = 0; }

            $('#queuereadycounter').html('<h1>'+currentavailable+'</h1>');
            console.log('available '+currentavailable);

        },
        callback_queuemembers: function(nro,texto,slot) {
            console.log('calculate ready on all');
            plugins['queuereadycounter'].calculate_ready();
        },
        callback_queuemember: function(nro,texto,slot) {
            console.log('calculate ready on member');
            plugins['queuereadycounter'].calculate_ready();
        }
    }
}());
